using System;
using System.Collections.Generic;
using System.Text;
using LinearProgramming;

namespace Test
{
    class Program
    {
        public static void PrintVars(LinearSpec ls)
        {
            foreach (Variable v in ls.Variables) Console.Write(v.Value + " ");
            Console.WriteLine(ls.Result);
        }

        static void Main(string[] args)
        {
            Test1();
            Console.ReadLine();
        }

        public static void Test1()
        {
            LinearSpec ls = new LinearSpec();
            Variable x1 = ls.AddVariable();
            Variable x2 = ls.AddVariable();
            Constraint c1 = ls.AddConstraint(new double[] { 1 }, new Variable[] { x1 }, OperatorType.LE, 108);
            Constraint c2 = ls.AddConstraint(new double[] { 1 }, new Variable[] { x2 }, OperatorType.GE, 113);
            ls.SetObjFunction(new double[] { 1, 1 }, new Variable[] { x1, x2 });
            ls.Solve();
            PrintVars(ls);

            c2.Remove();
            ls.Solve();
            PrintVars(ls);

            c2 = ls.AddConstraint(new double[] { 1 }, new Variable[] { x2 }, OperatorType.GE, 113);
            ls.Solve();
            PrintVars(ls);
        }


        public static void PenaltyFunctionTest1()
        {
            LinearSpec ls = new LinearSpec();
            Variable var = ls.AddVariable();

            ls.AddPenaltyFunction(
                    var,
                    new double[] { 1, 2, 3 },
                    new double[] { -2, -1, 1, 2 });
            ls.Solve();
            ls.Save("lse2.txt");
            Console.Write("result=" + ls.Result);
            Console.Write("\tvar=" + var.Value);
            Console.WriteLine("\tobj=" + ls.ObjectiveValue);

            for (double x = 0; x < 5; x += 0.5)
            {
                var.Min = var.Max = x;
                ls.Solve();
                Console.Write("result=" + ls.Result);
                Console.Write("\tvar=" + var.Value);
                Console.WriteLine("\tobj=" + ls.ObjectiveValue);
                foreach (Variable v in ls.Variables)
                    Console.Write(v + "=" + v.Value+"\t");
                Console.WriteLine();
            }
        }
    }
}
